// $Header: /u/s/o/solomon/java/rooms.tmp/RCS/ButtonFrame.java,v 1.1 1996/06/20 19:23:44 solomon Exp solomon $
// Copyright (c) 1996, Marvin Solomon
package rooms;

import java.applet.*;
import java.awt.*;

public class ButtonFrame extends Applet implements Constants {
	static void debug(String s) { Rooms.debug(s); }

	// Components
	Button helpButton, reserveButton, deleteButton;

	public void init() {
		// get parameters (ok if they're not present)
		Rooms.debugFlag = (getParameter("dbg")!=null);
		Rooms.barrier.start(0);
		Rooms.ticket = getParameter("allowUpdates");
		String tmp = getParameter("cgiBin");
		if (tmp != null)
			Rooms.cgiBin = tmp;
		else debug("cgiBin not set!");

		//setBackground(Color.white);
		//setForeground(Color.black);

		// Choose fonts (unfortunately, "10 point" means
		// different things, even between versions of Netscape on SPARC
		// Solaris!)
		int fontSize;
		Font f = null;
		for (fontSize = 10; fontSize < 16; fontSize++) {
			f = new Font("TimesRoman", Font.PLAIN, fontSize);
			if (getFontMetrics(f).charWidth('0') >= 7) break;
		}
		Rooms.defaultFont = f;
		Rooms.smallFont = new Font("TimesRoman", Font.PLAIN, fontSize-2);

		// set layout
		GridBagLayout gridBag = new GridBagLayout();
		setLayout(gridBag);

		// set up constraints
		GridBagConstraints c = new GridBagConstraints();
		c.anchor = GridBagConstraints.CENTER;	// center in available space
		c.gridwidth = GridBagConstraints.REMAINDER; // last in row

		// generate buttons
		helpButton = new Button("Help");
		reserveButton = new Button("New Reservation");
		deleteButton = new Button("Delete Reservation");
		helpButton.setFont(Rooms.defaultFont);
		reserveButton.setFont(Rooms.defaultFont);
		deleteButton.setFont(Rooms.defaultFont);

		// initially only "help" is enabled
		reserveButton.disable();
		deleteButton.disable();

		// add buttons to the button box
		gridBag.setConstraints(helpButton, c);
		add(helpButton);
		gridBag.setConstraints(reserveButton, c);
		add(reserveButton);
		gridBag.setConstraints(deleteButton, c);
		add(deleteButton);

		// register with the central dispatcher
		Rooms.buttonBox = this;
		Rooms.barrier.finish(0);
	}

	// Respond to mouse clicks in the buttons
	public boolean action(Event event, Object arg) {
		if (Rooms.disabled) return false;
		if (event.target == reserveButton) {
			String info = 
				"reserve "	+Rooms.resRoom
				+" from "	+Rooms.resStart
				+" until "	+Rooms.resEnd
				+" on "		+Rooms.calendar.fullDate();
			String cmd =
				"reserve "	+Rooms.resRoom
				+" "		+Rooms.resStart
				+" "		+Rooms.resEnd
				+" "		+Rooms.calendar.shortDate();
			Rooms.disabled = true; // reset to false from inside DialogWindow
			new DialogWindow(DialogWindow.CREATE, info, cmd).show();
			return true;
		}
		else if (event.target == deleteButton) {
			Rooms.disabled = true; // reset to false from inside DialogWindow
			new DialogWindow(DialogWindow.DELETE,
				Rooms.currentSelection.detail,
				"delete "+Rooms.currentSelection.id).show();
			return true;
		}
		else if (event.target == helpButton) {
			// Rooms.disabled = true; (don't make help dialog modal!)
			new DialogWindow(DialogWindow.HELP,
				Rooms.ticket==null ? readOnlyHelp : readWriteHelp,
				null).show();
			return true;
		}
		return false;
	}
}
