// $Header: /u/s/o/solomon/java/rooms.tmp/RCS/Constants.java,v 1.1 1996/06/20 19:23:44 solomon Exp solomon $
// Copyright (c) 1996, Marvin Solomon

package rooms;

import java.awt.Color;
import java.awt.Font;

interface Constants {
	final static String[] monthName = {
		"January", "February", "March", "April",
		"May", "June", "July", "August",
		"September", "October", "November", "December",
	};
	final int[] numDays = { 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 };
	final static String[] dayname = {
		"Sunday", "Monday", "Tuesday", "Wednesday", "Thursday",
		"Friday", "Saturday"
	};

	// List of names of rooms that may be reserved.  The order they are listed
	// here controls the order of the columns in the display.
	final static String[] roomName = {
		"2310", "3331", "5331", "7331", "1304", "1325", "1240"
		//"2310", "3331", "5331", "7331", "1325", "1240"
	};

	// Lots of sizes, in pixels (there should be better way to do this!)
	final static int ROOM_NAME_HEIGHT =		20;
	final static int TIME_PERIOD_WIDTH =	35;
	final static int TIME_SLOT_HEIGHT =		8;
	final static int ROOM_WIDTH =			40;

	// Parameters controlling the number of rows
	final static int START_HR =				8; // 8 am
	final static int DURATION_SHOWN =		11; // 11 hours total
	final static int TIME_INTERVAL =		15; // 15 minutes/row

	// Calculated dimensions
	final static int TIME_PERIODS =				// number of rows
		DURATION_SHOWN * 60/TIME_INTERVAL;
	final static int GRID_HEIGHT =				// total height of grid
		ROOM_NAME_HEIGHT + TIME_PERIODS * TIME_SLOT_HEIGHT;
	final static int GRID_WIDTH =				// total width of grid
		TIME_PERIOD_WIDTH + roomName.length * ROOM_WIDTH;

	// Colors.
	// Currently optimized for grey-scale monitors.
	// Should be made more colorful for color monitors and more legible
	// for black and white.
	final static Color SEL_RES_COLOR = new Color(240, 240, 240);
		// color of the selected reservation
	final static Color RES_COLOR = Color.lightGray; // Color(192,192,192)
		// color of other reservations

	// Misc constants
	final static String DEFAULT_MSG =
			"  Click in any shaded area in the grid below\n"+
			"  for more information about that reservation";

	// Help messages
	final static String commonHelp = "\n"
	+ " To see the reservations for a particular date, click on that\n"
	+ " date in the calendar.  To see standing (weekly) reservations,\n"
	+ " click on one of the letters (S M T W T F S) at the top of\n"
	+ " the calendar.  Use the `<' and `>' buttons to change to a\n"
	+ " different month.  To learn more about a particular\n"
	+ " reservation, click on it and read the message in the box\n"
	+ " above the reservation grid.";

	final static String readOnlyHelp = commonHelp + " \n\n"
	+ " Another version of this page allows registered users to\n"
	+ " create and delete reservations.  See the instructions at the\n"
	+ " top of the page.";

	final static String readWriteHelp = commonHelp + " \n\n"
	+ " To make a new reservation, select the appropriate date or day\n"
	+ " of the week as above, click and drag to outline the desired\n"
	+ " area, and then click the `New Reservation' button.  A dialog\n"
	+ " will pop up.  Enter a short description of the reason for\n"
	+ " your reservation (this is required!) and click `Make Reservation'.\n"
	+ " If you change your mind, click `Cancel' instead.\n"
	+ " Error messages appear in the box above the reservation grid.\n\n"

	+ " To delete an existing reservation, click on it, click\n"
	+ " `Delete Reservation', and click `Delete Reservation' in the\n"
	+ " dialog box that pops up.  You can delete anybody's reservation,\n"
	+ " but the rooms database will record your name, so only\n"
	+ " delete a reseration after you get permission from the person\n"
	+ " who made it.\n";
}
