// $Header: /u/s/o/solomon/java/rooms.tmp/RCS/MonthChooser.java,v 1.5 1996/06/20 19:23:44 solomon Exp solomon $
package rooms;
// Copyright (c) 1996, Marvin Solomon

import java.applet.Applet;
import java.awt.Font;
import java.awt.Panel;
import java.awt.Label;
import java.awt.Button;
import java.awt.Color;
import java.awt.Event;
import java.util.Date;


import java.awt.*;

// A MonthChooser is a way of choosing a month.  It consists of a Label
// indicating the current choice, and forward and back buttons to move it
// one month at a time in either direction.  Each time it changes the
// month, it calls peer.setDate(month, day, year), where (month,year) is
// the current choice, and day is 1 or 32 depending on which way you were
// moving.  The initial setting is indicated by the constructor.
public class MonthChooser extends Applet implements Constants {
	// Arguments to constructor
	int month, year;

	// Component applets
	Label label;
	Button left, right;

	static void debug(String s) { Rooms.debug(s); }

	public void init() {
		// Initialize to the current month
		Rooms.barrier.start(2);
		Date today = new Date();
		month = today.getMonth();
		year = today.getYear();

		// Set up graphics context
		//setBackground(Color.white);
		//setForeground(Color.black);

		// layout
		setLayout(new BorderLayout());

		// Build components
		//label = new Label(" XXXXXXXXX " + " " + (1900+year), Label.CENTER);
		label = new Label("  XXXXXXXXXXXXXXXXXX  ", Label.CENTER);
		left = new Button("<");
		right = new Button(">");
		label.setFont(Rooms.defaultFont);
		left.setFont(Rooms.defaultFont);
		right.setFont(Rooms.defaultFont);

		// Lay them out (using default Layout)
		add("West",left);
		add("East",right);
		add("Center",label);

		Rooms.chooser = this;
		Rooms.barrier.finish(2);
		label.setText("   " + monthName[month] + "   " + (1900+year));
		repaint();
	}

	// Respond to button clicks
	public boolean action(Event e, Object arg) {
		if (Rooms.disabled) return false;
		if (e.target==left) { // Previous month
			if (--month < 0) { month = 11; year--; }
		}
		else if (e.target==right) { // Next month
			if (++month > 11) { month = 0; year++; }
		}
		else // Can't happen?
			debug("event "+e+" in object "+e.target);
		label.setText(monthName[month] + " " + (1900+year));
		repaint();
		Rooms.update();
		return false;
	}
} // MonthChooser
