// $Header: /u/s/o/solomon/java/rooms.tmp/RCS/Reservation.java,v 1.5 1996/06/20 19:23:44 solomon Exp solomon $
// Copyright (c) 1996, Marvin Solomon

package rooms;

// Used by ReservationGrid to maintain a list of reservations.
class Reservation {
	String id;
	int room, start, end;
		// room is a column number, start and end are row numbers.
		// interval is [start,end)
	String detail;
	Reservation next;
	public Reservation(String id, int r, int s, int e, String d, Reservation n) {
		int i, j;

		this.id = id;
		room = r;
		start = s;
		end = e;
		// Simplify the detail
		d = d.trim();
		// Remove all substrings in brackets
		for (;;) {
			if ((i = d.indexOf('[')) < 0) break;
			if ((j = d.indexOf(']',i+1)) < 0) break;
			d = d.substring(0,i) + d.substring(j+1);
		}
		// Remove all substrings in parentheses
		for (;;) {
			if ((i = d.indexOf('(')) < 0) break;
			if ((j = d.indexOf(')',i+1)) < 0) break;
			d = d.substring(0,i) + d.substring(j+1);
		}
		detail = d;
		next = n;
	}
	public String toString() {
		return "Reservation["+room+","+start+","+end+"]";
	}
	boolean hits(int row, int col) {
		return room == col && row >= start && row < end;
	}
} // Reservation
